#!/usr/bin/perl

# # diffAlg - Differential algebra library
# # 
# # Copyright (C) 2012 Manuel Dubinsky, Cesar Massari, Ariel Molinuevo
# # 
# # 
# # This program is free software: you can redistribute it and/or modify
# # it under the terms of the GNU General Public License as published by
# # the Free Software Foundation, either version 3 of the License, or
# # (at your option) any later version.
# # This program is distributed in the hope that it will be useful,
# # but WITHOUT ANY WARRANTY; without even the implied warranty of
# # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# # GNU General Public License for more details.
# # You should have received a copy of the GNU General Public License
# # along with this program. If not, see <http://www.gnu.org/licenses/>.

use DB_File;
use Form;

my $varName = "X";
my $n;

sub fieldPoly {
	my ($file) = @_;
	
	my @polys;
	for (my $i = 0; $i < $n;$i++) {
		# Ojo con el cero!!!! (Manuel D.*y)
		$polys[$i] = "0";
	}	

	tie %h, "DB_File", $file;
	map {
		my ($i, $m) = split(";", $_);
		my @monomExp = split(",", $m);
		my $monom = "";
		for (my $j = 0; $j < $n; $j++) {
				if ($monomExp[$j]) {
					$monom .= (length($monom) > 0 ? "*" : "") . $varName ."_". ($j+1) . "^" . $monomExp[$j];
				}
		}
		if ($h{$_}) {
			$polys[$i-1] .= (length($polys[$i-1]) > 0 ? "+" : "") . "(" . $h{$_} . ")*" . $monom;
		}	
	} keys(%h);
	untie %h;
	return @polys;
}

#for (my $i=0; $i < $n; $i++) {
#	print $polys[$i] . "\n";
#}
my $fields = @ARGV;
my %h;
tie %h, "DB_File", $ARGV[0] . ".meta";
$n = $h{n};
untie %h;

my $distFile = "dist/distributionMatrix";
if (-e $distFile) {
	unlink($distFile);
}
tie %h, "DB_File",  $distFile;
for (my $i = 0; $i < $fields; $i++) {
	my @p = fieldPoly($ARGV[$i]);
	for (my $j = 0; $j < $n; $j++) {
		$h{$i.";".$j} = $p[$j];
	}
}
untie %h;

# for (my $i = 0; $i < $fields; $i++) {
# 	for (my $j = $i + 1; $j < $fields; $j++) {
# 		my $bracket = lieBracket(newForm($ARGV[$i]), newForm($ARGV[$j]));
# 		my @p = fieldPoly($bracket->{formFile});
# 		my $bracketFile = $distFile . "_[" . $ARGV[$i] . "," . $ARGV[$j] . "]";
# 		#Ojo con el cp!! (Ariel M.*o)
# 		`cp $distFile $bracketFile`;
# 		tie %h, "DB_File",  $bracketFile;
# 		for (my $k = 0; $k < $n; $k++) {
# 			$h{($n+1).";".$k} = $p[$k];
# 		}
# 		untie %h;
# 	}
# }

# pasamos a Singular (Cesar M*i :) )...
open(OUT, ">$distFile.singular");
my $ringVars = "X_1";
for (my $i=1; $i < $n; $i++) {
	$ringVars .= ",X_" . ($i+1);
}
print OUT "ring r = (0,i),(" . $ringVars . "),dp;minpoly = i^2+1;\n";

print OUT "matrix D[". $fields ."][".$n."]=";
tie %h, "DB_File",  $distFile;
for (my $i = 0; $i < $fields; $i++) {
	for (my $j = 0; $j < $n; $j++) {
		print OUT ($i>0 || $j>0 ? "," : "");
		print OUT $h{$i.";".$j};
	}
}
untie %h;

# esto despues hay que sacarlo
# print OUT ";\n";

print OUT ";\nrank(D);\n";

for (my $i = 0; $i < $fields; $i++) {
	for (my $j = $i + 1; $j < $fields; $j++) {
		my $bracket = lieBracket(newForm($ARGV[$i]), newForm($ARGV[$j]));
		my @p = fieldPoly($bracket->{formFile});
		my $matrix = "D" . $i . "_" . $j;
		print OUT "matrix " . $matrix . "[". ($fields + 1) ."][".$n."]=D,";
		print OUT join(",",@p);
		print OUT ";\n";
		print OUT "rank($matrix);\n";
	}
}
close(OUT);


# my $ringVars = "X_1";
# for (my $i=1; $i < $n; $i++) {
# 	$ringVars .= ",X_" . ($i+1);
# }
# print "ring r = (0,i),(" . $ringVars . "),dp;minpoly = i^2+1;\n";
# print "matrix A[". @ARGV ."][".$n."]=";
# for (my $i = 0; $i < @ARGV; $i++) {
# # print "$i\n";
# 	my @p = fieldPoly($ARGV[$i]);

# 	print ($i>0 ? "," : ""); print join(",",@p);
# }

# print ";\n";

