#!/usr/bin/perl

# # diffAlg - Differential algebra library
# # 
# # Copyright (C) 2012 Manuel Dubinsky, Cesar Massari, Ariel Molinuevo
# # 
# # 
# # This program is free software: you can redistribute it and/or modify
# # it under the terms of the GNU General Public License as published by
# # the Free Software Foundation, either version 3 of the License, or
# # (at your option) any later version.
# # This program is distributed in the hope that it will be useful,
# # but WITHOUT ANY WARRANTY; without even the implied warranty of
# # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# # GNU General Public License for more details.
# # You should have received a copy of the GNU General Public License
# # along with this program. If not, see <http://www.gnu.org/licenses/>.

use DB_File ;
use Form;

if (scalar(@ARGV) == 4) {
	my ($n, $r, $d, $file)= @ARGV;
	my $tmpFile = "tmp/" . $file . ".tmp";
	open(OUT, ">$file.mk");
	newForm($n, $r, $d, $tmpFile, null);
	tie %h, "DB_File", $tmpFile;
	map {
		print OUT $_ . " = 0\n"
	} keys(%h);
	untie %h;
	unlink($tmpFile);
	close(OUT);
	
	open(OUT, ">$file.mk.meta");
	print OUT "formFile = $file\n";
	print OUT "formVars = \n";
	print OUT "n = $n\n";
	print OUT "r = $r\n";
	print OUT "d = $d\n";
	close(OUT)
} elsif (scalar(@ARGV) == 1) {
	my ($file) = @ARGV;
	open(IN, "<$file.mk");
	tie %h, "DB_File", $file;
	while (<IN>) {
		chomp;
		s/\s//g;
		my ($key, $value) = split("=", $_);
		$h{$key} = $value;
	}
	untie %h;
	close(IN);
	
	open(IN, "<$file.mk.meta");
	tie %h, "DB_File", $file . ".meta";
	while (<IN>) {
		chomp;
		s/\s//g;
		s/,/ /g;
		my ($key, $value) = split("=", $_);
		$h{$key} = $key eq "formFile" ? $file : $value;
	}
	untie %h;
	close(IN);
}